authentication/urls.py
from django.contrib.auth.views import LogoutView
from django.urls import path, include

from authentication import views
from authentication.api.router import router
from sgp import settings

app_name = 'authentication'
urlpatterns = [
    path('', views.SignInView.as_view(), name='login'),
    path('api/', include(router.urls)),
    path('api-auth/', include('rest_framework.urls')),
    path('logout/', LogoutView.as_view(), {'next_page': settings.LOGOUT_REDIRECT_URL}, name='logout'),
    path('register/', views.SignUpView.as_view(), name='register'),
    path('redirect-session', views.redirect_session, name='redirect_session'),
]

evaluator/urls.py
from django.urls import path

from evaluator import views

app_name = 'evaluator'
urlpatterns = [
    path('dashboard/', views.DashboardView.as_view(), name='dashboard'),
    path('qualified/<int:id_project>', views.ProjectsQualifiedView.as_view(), name='qualified'),
    path('project/scores/<int:id_project>', views.ProjectScoresQuestionView.as_view(), name='get_scores'),
    path('projects/questions/<int:id>', views.ProjectQuestionsView.as_view(), name='get_questions_project'),
    path('projects/questions-detail/<int:id>', views.ProjectDescriptionQuestionView.as_view(),
         name='get_question_detail'),
]

sgp/urls.py
from django.contrib import admin
from django.urls import path, include
from django.conf.urls.static import static

from sgp import settings

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('authentication.urls')),
    path('administrator/', include('administrator.urls')),
    path('evaluator/', include('evaluator.urls')),
    path('projects/', include('projects.urls')),
    path('writer/', include('writer.urls')),
] + static(settings.STATIC_URL, document_root=settings.STATIC_ROOT) + static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

evaluator/models.py
from django.contrib.auth.models import User
from django.db import models

from core.models import BaseModel, Category


class Evaluator(BaseModel):
    user = models.OneToOneField(User, on_delete=models.CASCADE)
    category = models.ManyToManyField(Category)

    def __str__(self):
        return self.user.username

    class Meta:
        db_table = "evaluators"
        verbose_name = "Evaluador"
        verbose_name_plural = "Evaluadores"

evaluator/views.py
import json

from django.contrib.auth.mixins import LoginRequiredMixin
from django.db.models import Sum, Q
from django.http import JsonResponse
from django.shortcuts import render, redirect
from django.urls import reverse_lazy
from django.views import View

from authentication.models import UserInformation
from core.models import Category
from evaluator.evaluator_controller import EvaluatorController
from evaluator.models import Evaluator
from projects.models import Score, Project, Question, FilesApp


class DashboardView(LoginRequiredMixin, View):
    template_name = "evaluator/dashboard.html"

    def get(self, request, *args, **kwargs):
        to_evaluate = Score.objects.filter(
            evaluator__user=request.user,
            project__status=Project.SEND,
            extra__isnull=True,
            question__isnull=True

        )
        return render(request, self.template_name, {'to_evaluate': to_evaluate})

    def post(self, request, *args, **kwargs):
        pass


class ProjectsQualifiedView(LoginRequiredMixin, View):
    template_name = "evaluator/project_qualified.html"

    def get(self, request, *args, **kwargs):
        id_project = kwargs.get('id_project')
        is_assigned = Score.objects.filter(
            evaluator__user=request.user,
            project__status=Project.SEND,
            project_id=id_project,
        ).exists()
        if not is_assigned:
            return redirect(reverse_lazy('evaluator:dashboard'))

        user = UserInformation.objects.get(user_id=request.user.id)
        project = Project.objects.get(id=kwargs.get('id_project'))
        categories_project = [{'id': cat.id, 'name': cat.name} for cat in project.category.only('id', 'name')]
        categories = Category.objects.all()
        return render(request, self.template_name, {
            'user': user,
            'project': project,
            'categories_project': categories_project,
            'categories': categories,
            'count_items': Question.objects.filter(
                project_id=id_project
            ).count()
        })


class ProjectQuestionsView(LoginRequiredMixin, View):

    def get_score(self, id_q):
        sc = Score.objects.filter(question_id=id_q).only('score').values('score').first()
        return int(sc.get('score')) if sc else 0

    def get(self, request, *args, **kwargs):
        query = Question.objects.filter(
            project_id=kwargs.get('id'),
        ).only('id', 'title')
        questions = [{'id': q.id, 'title': q.title, 'score': self.get_score(q.id)} for q in query]
        return JsonResponse(status=200, data={'questions': questions})

    def put(self, request, *args, **kwargs):
        data = json.loads(request.body)
        print(data)
        score = data.get('score', 0)
        item_id = data.get('item_id', None)
        extra = data.get('extra', None)
        id_project = data.get('id_project', None)
        evaluator = Evaluator.objects.get(user=request.user)

        if extra:
            sc = Score.objects.filter(project_id=id_project, extra=extra).only('score').first()
        else:
            sc = Score.objects.filter(question_id=item_id).only('score').first()

        if sc and sc.score != score:
            sc.score = score
            sc.save()

        if not sc:
            print('=' * 30)
            print(float(score))
            sc = Score.objects.create(
                score=float(score),
                evaluator=evaluator,
                project_id=id_project,
                extra=extra
            )

            if not extra and item_id:
                sc.question_id = item_id
                sc.save()

        return JsonResponse(
            status=200,
            data={
                'item': {'id': sc.id, 'score': sc.score},
                'message': 'Calificación guardada exitosamente',
                'alert': 'success'
            }
        )


class ProjectDescriptionQuestionView(LoginRequiredMixin, View):

    def get_score(self, id_q):
        sc = Score.objects.filter(question_id=id_q).only('score').values('score').first()
        return int(sc.get('score')) if sc else 0

    def get(self, request, *args, **kwargs):
        query = Question.objects.get(
            id=kwargs.get('id'),
        )
        return JsonResponse(
            status=200,
            data={
                'id': query.id, 'title': query.title, 'answer': query.answer, 'score': self.get_score(query.id)
            }
        )


class ProjectScoresQuestionView(LoginRequiredMixin, View):

    def get(self, request, *args, **kwargs):
        return JsonResponse(
            status=200,
            data=EvaluatorController.get_score_project(kwargs.get('id_project'))
        )

evaluator/templates/evaluator/base.html
{% extends 'base.html' %}

{% block body_tags %}class="with-content-panel"{% endblock %}

{% block content %}
    <div class="all-wrapper menu-side with-side-panel" id="app">
        {% block extra_content_alert %}{% endblock %}
        <div class="layout-w">

            {% include 'evaluator/sidebar-left.html' %}

            <div class="content-w">
                <!--------------------  START - Breadcrumbs  -------------------->
                <ul class="breadcrumb">
                    <li class="breadcrumb-item">
                        <a href="{% url 'evaluator:dashboard' %}">Inicio</a>
                    </li>
                    {% block breadcrumb %}{% endblock %}
                </ul>
                <!--------------------  END - Breadcrumbs -------------------->
                <div class="content-panel-toggler">
                    <i class="os-icon os-icon-grid-squares-22"></i><span>Sidebar</span>
                </div>
                <div class="content-i">
                    <div class="content-box">

                        {% block content_writer %}{% endblock %}


                        <div class="floated-colors-btn first-floated-btn" id="dark-mode" @click="setDarkMode">
                            <div class="os-toggler-w" style="margin-right: 0">
                                <div class="os-toggler-i">
                                    <div class="os-toggler-pill"></div>
                                </div>
                            </div>
                        </div>

                    </div>
                </div>
            </div>
        </div>
        <div class="display-type"></div>
    </div>
    {% csrf_token %}
{% endblock %}

{% block _js %}
    <script src="https://unpkg.com/vue@3"></script>
    <script type="importmap">
      {
        "imports": {
          "vue": "https://unpkg.com/vue@3/dist/vue.esm-browser.js"
        }
      }

    </script>


    <script type="module">
        import {createApp} from 'vue'

        createApp({
            delimiters: ['${', '}'],
            data() {
                return {
                    show_intro: false
                }
            },
            mounted() {
                // this.checkDarkMode()
            },
            methods: {
                /*setDarkMode() {
                    if ($('body').hasClass('color-scheme-dark')) {
                        localStorage.setItem('dark-mode', '0')
                    } else {
                        localStorage.setItem('dark-mode', '1')
                    }

                },
                checkDarkMode() {
                    let localStore = localStorage.getItem('dark-mode')
                    console.log('localStore: ', localStore)
                    if (localStore) {
                        let active = parseInt(localStore) === 1 ? true : false
                        console.log('active: ', active)
                        this.activeDarkMode(active)
                    } else {
                        let darkMode = window.matchMedia('(prefers-color-scheme: dark)').matches;
                        if (darkMode) {
                            this.activeDarkMode(true)
                        }

                    }
                },
                activeDarkMode(active) {
                    let el = document.getElementById('dark-mode')
                    if ($('body').hasClass('color-scheme-dark') || !active) {
                        console.log('removing')
                        $('.desktop-menu').removeClass('color-scheme-dark');
                        $(el).find('.os-toggler-w').removeClass('on');
                        $('body').removeClass('color-scheme-dark');
                    } else {
                        $('.desktop-menu').addClass('color-scheme-dark');
                        $(el).find('.os-toggler-w').addClass('on');
                        $('body').addClass('color-scheme-dark');
                    }

                    return false;
                },*/
                closeIntro() {
                    fetch('http://127.0.0.1:8000/api/user/{{ request.user.id }}/', {
                        method: 'PUT',
                        body: JSON.stringify({show_intro: false}),
                        headers: {
                            'Content-Type': 'application/json',
                            'X-CSRFToken': document.getElementsByName('csrfmiddlewaretoken')[0].value
                        }
                    }).then(response => {
                        response.json().then(res => {
                            console.log(res)
                        })
                    }).catch((e) => {
                        console.error(e)
                    })
                }
            }
        }).mount('#app')
    </script>

    {% block js %}{% endblock js %}

{% endblock _js %}

evaluator/templates/evaluator/base_evaluator.html
{% extends 'evaluator/base.html' %}
{% load static evaluator_tag %}


{% block _css %}
    <style>
        .danger-color {
            color: #e65252;
        }
        .href-view-project {
            display: flex!important;
            justify-content: space-between;
        }
        .qualification {
            font-size: 12px;
            font-weight: bold;
            margin-right: 5px;
        }
        .qualification.approved {
            color: #4d9121;
        }
        .qualification.reapproved {
            color: #e65252;
        }
        @media (max-width: 1650px) {
            body.with-content-panel .content-box {
                padding-left: 2rem!important;
            }
        }
    </style>

{% endblock %}

{% block content_writer %}
    <div class="todo-app-w">
        <!--END - To Do SIDEBAR-->
        <div class="todo-content">
            {% block content_block %}{% endblock content_block %}
        </div>
    </div>

{% endblock %}

evaluator/templates/evaluator/dashboard.html
{% extends 'base.html' %}

{% load static evaluator_tag %}

{% block body_tags %}class="with-content-panel"{% endblock %}


{% block content %}
    <div class="all-wrapper menu-side with-side-panel">
        <div class="layout-w">

            {% include 'evaluator/sidebar-left.html' %}

            <div class="content-w">
                <!--------------------  START - Breadcrumbs  -------------------->
                <ul class="breadcrumb">
                    <li class="breadcrumb-item">
                        <a href="index.html">Home</a>
                    </li>
                    <li class="breadcrumb-item">
                        <a href="index.html">Products</a>
                    </li>
                    <li class="breadcrumb-item">
                        <span>Laptop with retina screen</span>
                    </li>
                </ul>
                <!--------------------  END - Breadcrumbs -------------------->
                <div class="content-panel-toggler">
                    <i class="os-icon os-icon-grid-squares-22"></i><span>Sidebar</span>
                </div>
                <div class="content-i">
                    <div class="content-box">
                        <div class="row">
                            <div class="col-sm-12">
                                <div class="element-wrapper">
                                    <h6 class="element-header">
                                        Proyectos
                                    </h6>
                                    <div class="element-box">
                                        <div class="table-responsive">
                                            <table class="table table-lightborder">
                                                <thead>
                                                <tr>
                                                    <th>
                                                        Título
                                                    </th>
                                                    <th>
                                                        Descripción
                                                    </th>
                                                    <th class="text-right">
                                                        Calificación
                                                    </th>
                                                    <th class="text-right">
                                                        Acciones
                                                    </th>
                                                </tr>
                                                </thead>
                                                <tbody>
                                                {% for sc in to_evaluate %}
                                                    <tr>
                                                        <td class="nowrap">
                                                            {{ sc.project.title }}
                                                        </td>
                                                        <td class="nowrap">
                                                            {% autoescape off %}
                                                                {{ sc.project.description|truncatechars_html:100 }}
                                                            {% endautoescape %}
                                                        </td>
                                                        <td class="nowrap text-right">
                                                            {{ sc.project_id|get_score }}
                                                        </td>
                                                        <td class="nowrap text-right">
                                                            <a href="{% url 'evaluator:qualified' sc.project_id %}">
                                                                <i class="os-icon os-icon-ui-49"></i> Calificar</a>
                                                        </td>
                                                    </tr>
                                                {% endfor %}
                                                </tbody>
                                            </table>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="display-type"></div>
    </div>
{% endblock %}

evaluator/templates/evaluator/menu.html
<li>
    <a href="{% url 'evaluator:dashboard' %}">
        <div class="icon-w">
            <div class="os-icon os-icon-window-content"></div>
        </div>
        <span>Dashboard</span>
    </a>
</li>
<li>
    <a href="{% url 'authentication:logout' %}">
        <div class="icon-w">
            <div class="os-icon os-icon-signs-11"></div>
        </div>
        <span>Cerrar sesión</span>
    </a>
</li>

evaluator/templates/evaluator/project_qualified.html
{% extends 'evaluator/base_evaluator.html' %}
{% load static %}


{% block extra_css %}
    <link href="{% static 'icon_fonts_assets/batch-icons/style.css' %}" rel="stylesheet">


    <link href="{% static 'css/gallery.css' %}" rel="stylesheet">
    <style>
        .content-answer {
            padding: 12px 15px;
            background: #f4f4f4;
            border: 1px solid #f4f4f4;
            margin-bottom: 15px;
        }

        .add-item {
            display: flex;
            flex-direction: column;
            justify-content: center;
            align-items: center;
            min-height: 30%;
            width: 100%;
            opacity: .5;
            cursor: pointer;
            background-color: rgba(238, 238, 238, 0.5)
        }

        .add-item:hover {
            opacity: 1;
        }

        .add-item i {
            font-size: 3rem;
            margin-bottom: 15px;
        }

        .add-item span {
            font-size: 1.5rem;
            text-align: center;
        }

        .bg-item {
            background-color: rgba(238, 238, 238, 0.5)
        }

        a.disabled {
            pointer-events: none;
            cursor: default;
        }

        .title-resume-item {
            display: flex;
            justify-content: space-between;
            align-items: center;
        }

        .title-resume-item h5 {
            margin: 0;
        }

        .btn-delete-item {
            position: absolute;
            right: 22px;
            top: 5px;
        }

        .btn-delete-item,
        .btn-remove {
            padding: 12px 16px !important;
            font-weight: bold;
            background-color: #ffffff !important;
            border: 0;
            box-shadow: 0px 2px 4px rgb(126 142 177 / 12%);
            border-radius: 5px;
            z-index: 0;
            cursor: pointer !important;
            opacity: 1;
            font-size: 10px;
        }

        .btn-remove,
        .btn-delete-item span {
            font-weight: bold;
        }

        .btn-remove,
        .btn-delete-item:hover {
            color: red;
        }

        .element-box-content mark {
            margin: 0 5px;
        }

        .tasks-list-w.general-data {
            padding: 15px;
            border-radius: 10px;
            background-color: #F9F9F9;
        }

        pre {
            white-space: pre-wrap;
        }

        .tasks-header.tasks-header-toggler {
            position: relative !important;
            left: 0 !important;
            top: 10px !important;
            color: #334151 !important;
            cursor: pointer;
        }

        .show-item {
            position: fixed;
            width: 100%;
            height: 100vh;
            background-color: #fff;
            z-index: 99;
            left: 0;
            top: 0;
            overflow: scroll;
        }

        .cke_dialog {
            z-index: 10010;
        }

        :root {
            --form-control-color: rebeccapurple;
        }

        .form-radio {
            display: flex;
            justify-content: center;
        }

        .radio-control {
            font-family: system-ui, sans-serif;
            font-size: 2rem;
            font-weight: bold;
            line-height: 1.1;
            margin: 1rem;
            text-align: center;
        }

        .radio-control:focus-within {
            color: var(--form-control-color);
        }

        input[type=radio] {
            /* Add if not using autoprefixer */
            -webkit-appearance: none;
            /* Remove most all native input styles */
            -moz-appearance: none;
            appearance: none;
            /* For iOS < 15 */
            background-color: var(--form-background);
            /* Not removed via appearance */
            margin: 0;
            font: inherit;
            color: currentColor;
            width: 1.15em;
            height: 1.15em;
            border: 0.15em solid currentColor;
            border-radius: 50%;
            transform: translateY(-0.075em);
            display: grid;
            place-content: center;
        }

        input[type=radio]::before {
            content: "";
            width: 0.65em;
            height: 0.65em;
            border-radius: 50%;
            transform: scale(0);
            transition: 120ms transform ease-in-out;
            box-shadow: inset 1em 1em var(--form-control-color);
            /* Windows High Contrast Mode */
            background-color: CanvasText;
        }

        input[type=radio]:checked::before {
            transform: scale(1);
        }

        input[type=radio]:focus {
            outline: max(2px, 0.15em) solid currentColor;
            outline-offset: max(2px, 0.15em);
        }

        .q-general {
            font-size: 30px;
        }
    </style>
{% endblock extra_css %}


{% block content_block %}
    <div id="v-app">
        <div id="stepContent1" v-show="step==1">
            <h4 class="todo-content-header">
                <i class="os-icon os-icon-ui-83"></i><span>{{ project.title }}</span>
                <button class="close btn-remove q-general"
                        type="button" @click="editItemProject(q.id)"
                        :style="{ color: style_score }"
                    >
                        ${scoreT}/5
                    </button>
            </h4>
            <div class="all-tasks-w">
                {% include 'evaluator/qualified/content_data_general.html' %}
                {% include 'evaluator/qualified/content_data_items.html' %}
                {% include 'evaluator/qualified/content_data_files.html' %}
            </div>
            <div class="form-buttons-w text-right" v-if="isEditable">
                <button class="btn btn-secondary"
                        data-target="#deleteProjectModal"
                        data-toggle="modal">
                    Eliminar
                </button>
                <button @click="draftProject" class="btn btn-info step-trigger-btn">
                    Guardar borrador
                </button>
                <button @click="showStep(2)" class="btn btn-primary step-trigger-btn">
                    Continuar
                </button>
            </div>
        </div>

        <div aria-hidden="true" class="modal fade" id="deleteProjectModal" role="dialog" tabindex="-1">
            <div class="modal-dialog modal-md" role="document">
                <div class="modal-content">
                    <div class="modal-header faded smaller">
                        <div class="modal-title">
                            <span>{{ project.title }} </span>
                        </div>
                        <button aria-label="Close" class="close" data-dismiss="modal" type="button"><span
                                aria-hidden="true"> &times;</span></button>
                    </div>
                    <div class="modal-body row">
                        <div class="col-12">
                            <h4>Estás seguro de querer eliminar este proyecto?</h4>
                        </div>
                    </div>
                    <div class="modal-footer buttons-on-left">
                        <button class="btn btn-teal" type="button" @click="deleteProject({{ project.id }})">
                            Si, eliminar
                        </button>
                        <button class="btn btn-link" data-dismiss="modal" type="button">Cancelar</button>
                    </div>
                </div>
            </div>
        </div>
    </div>
{% endblock %}

{% block _js %}

    {% include 'evaluator/qualified/script.html' %}

{% endblock %}

evaluator/templates/evaluator/sidebar-left.html
{% load static %}

<!-------------------- START - Mobile Menu  -------------------->
<div class="menu-mobile menu-activated-on-click color-scheme-dark">
    <div class="mm-logo-buttons-w">
        <a class="mm-logo" href="{% url 'evaluator:dashboard' %}">
            <img src="{% static 'img/logo.png' %}">
            <span>{{ request.user.username }}</span>
        </a>
        <div class="mm-buttons">
            <div class="content-panel-open">
                <div class="os-icon os-icon-grid-circles"></div>
            </div>
            <div class="mobile-menu-trigger">
                <div class="os-icon os-icon-hamburger-menu-1"></div>
            </div>
        </div>
    </div>
    <div class="menu-and-user">
        <div class="logged-user-w">
            <div class="avatar-w">
                <a href="{% url 'evaluator:dashboard' %}">
                    <img alt="" src="{% static 'img/avatar1.jpg' %}">
                </a>
            </div>
            <div class="logged-user-info-w">
                <div class="logged-user-name">
                    {{ request.user.full_name }}
                </div>
                <div class="logged-user-role">
                    {{ request.user.get_role }}
                </div>
            </div>
        </div>
        <!--------------------
        START - Mobile Menu List
        -------------------->
        <ul class="main-menu">
            {% include 'evaluator/menu.html' %}
        </ul>
        <!--------------------
        END - Mobile Menu List
        -------------------->
    </div>
</div>
<!-------------------- END - Mobile Menu-------------------->

<!--------------------  START - Menu side -------------------->
<div class="desktop-menu menu-side-w menu-activated-on-click" id="desktop-menu">
    <div class="logo-w">
        <a class="logo" href="{% url 'evaluator:dashboard' %}">
            <div class="logo-element"></div>
            <div class="logo-label">
                {{ request.user.username }}
            </div>
        </a>
    </div>
    <div class="menu-and-user">
        <div class="logged-user-w">
            <div class="logged-user-i">
                <div class="avatar-w">
                    <a href="{% url 'evaluator:dashboard' %}">
                        <img alt="" src="{% static 'img/avatar1.jpg' %}">
                    </a>
                </div>
                <div class="logged-user-info-w">
                    <div class="logged-user-name">
                        {{ request.user.full_name }}
                    </div>
                    <div class="logged-user-role">
                        {{ request.user.get_role }}
                    </div>
                </div>
            </div>
        </div>
        <ul class="main-menu">
            {% include 'evaluator/menu.html' %}
        </ul>
    </div>
</div>
<!-------------------- END - Menu side -------------------->